#!/home/config/bin/perl
#(c)1999 by Jan Rocho, jan@ude.org - GPL License v2
# http://ude.org/jan/perlseri
##############################################
##############################################
### DO NOT CHANGE ANYTHING BELOW THIS LINE ###
##############################################
##############################################


require("perlseti.conf") || die "Couldn't open the configuration file: perlseti.conf";


#######
## NEW in 2.0: We get the PID from the PID file which is created by the
## PerlSETI client!
#######

	open(PIDFILE, "pid.sah")||
			message(8);

		$client_pid = <PIDFILE>;
			chomp($client_pid);

   close(PIDFILE) || message(8);

$progversion = "2.1";
$progname = "PerlSETI4BeOS";
$sourceloc = "Arecibo Radio Observatory";
$| = 1;
$started=0;
$time_to_die=0;

sub signal_handler
{
    &logmsg("Ending client...");
    if($end_kill_client eq "1") {
       exec("kill $client_pid");
    }
    $time_to_die=1;

}
$SIG{INT}=$SIG{TERM}=$SIG{HUP}=\&signal_handler;

#while(true) {

until($time_to_die)
{

$started++;
message(0);


# Opening all the data files to get the DATA

open(PERLSETI_DATA_READ, "perlseti_data") || message(4);
   $bspikepwr = <PERLSETI_DATA_READ>; 		chomp($bspikepwr);
   $bspikescr = <PERLSETI_DATA_READ>; 		chomp($bspikescr);
   $spikeloc_ra = <PERLSETI_DATA_READ>; 	chomp($spikeloc_ra);
   $spikeloc_dec = <PERLSETI_DATA_READ>; 	chomp($spikeloc_dec);
   $bgauspwr = <PERLSETI_DATA_READ>; 		chomp($bgauspwr);
   $bgausscr = <PERLSETI_DATA_READ>; 		chomp($bgausscr);
   $gausloc_ra = <PERLSETI_DATA_READ>; 	chomp($gausloc_ra);
   $gausloc_dec = <PERLSETI_DATA_READ>; 	chomp($gausloc_dec);
close(PERLSETI_DATA_READ) || message(4);			 

open(STATE, "state.sah") || message(1);
   $ncfft = <STATE>; 		chomp($ncfft);
   $cr = <STATE>; 			chomp($cr);
   $fl = <STATE>; 			chomp($fl);
   $cpu = <STATE>; 			chomp($cpu);
   $prog = <STATE>; 		chomp($prog);
   $bs_power = <STATE>; 	chomp($bs_power);
   $bs_score = <STATE>; 	chomp($bs_score);
   $bs_bin = <STATE>; 		chomp($bs_bin);
   $bs_fft_ind = <STATE>; 	chomp($bs_fft_ind);
   $bs_chirp_rate = <STATE>; chomp($bs_chirp_rate);
   $bs_fft_len = <STATE>; 	chomp($bs_fft_len);
   $bg_score = <STATE>; 	chomp($bg_score);
   $bg_power = <STATE>; 	chomp($bg_power);
   $bg_chisq = <STATE>; 	chomp($bg_chisq);
   $bg_bin = <STATE>; 		chomp($bg_bin);
   $bg_fft_ind = <STATE>; 	chomp($bg_fft_ind);
   $bg_chirp_rate = <STATE>; chomp($bg_chirp_rate);
   $bg_fft_len = <STATE>; 	chomp($bg_fft_len);
close(STATE) || message(1);
	
open(USERINFO, "user_info.sah")|| message(3);
   $type = <USERINFO>; 			chomp($type);
   $id = <USERINFO>; 			chomp($id);
   $key = <USERINFO>; 			chomp($key);
   $email_addr = <USERINFO>; 	chomp($email_addr);
   $name = <USERINFO>; 			chomp($name);
   $url = <USERINFO>; 			chomp($url);
   $country = <USERINFO>; 		chomp($country);
   $postal_code = <USERINFO>; 	chomp($postal_code);
   $show_name = <USERINFO>; 	chomp($show_name);
   $show_email = <USERINFO>; 	chomp($show_email);
   $venue = <USERINFO>; 		chomp($venue);
   $register_time = <USERINFO>; chomp($register_time);
   $last_wu_time = <USERINFO>; 	chomp($last_wu_time);
   $last_result_time = <USERINFO>; chomp($last_result_time);
   $nwus = <USERINFO>; 			chomp($nwus);
   $nresults = <USERINFO>; 		chomp($nresults);
   $total_cpu = <USERINFO>; 	chomp($total_cpu);
   $params_index = <USERINFO>; 	chomp($params_index);
close(USERINFO) || message(3);

open(VERSION, "version.sah") || die "can't open version.txt: $!";
   $client_major = <VERSION>; 		chomp($client_major);
   $client_minor = <VERSION>; 		chomp($client_minor);
close(VERSION) || die "can't close version.txt: $!"; 

open(WORKUNIT, "work_unit.sah") || message(2);
   $type2 = <WORKUNIT>; 			chomp($type2);
   $task = <WORKUNIT>; 				chomp($task);
   $version = <WORKUNIT>; 			chomp($version);
   $name = <WORKUNIT>; 				chomp($name);
   $end_header = <WORKUNIT>; 		chomp($end_header);
   $data_type = <WORKUNIT>; 		chomp($data_type);
   $data_class = <WORKUNIT>; 		chomp($data_class);
   $splitter_version = <WORKUNIT>; 	chomp($splitter_version);
   $start_ra = <WORKUNIT>; 			chomp($start_ra);
   $start_dec = <WORKUNIT>; 		chomp($start_dec);
   $end_ra = <WORKUNIT>; 			chomp($end_ra);
   $end_dec = <WORKUNIT>; 			chomp($end_dec);
   $angle_range = <WORKUNIT>; 		chomp($angle_range);
   $time_recorded = <WORKUNIT>; 	chomp($time_recorded);
   $subband_center = <WORKUNIT>; 	chomp($subband_center);
   $subband_base = <WORKUNIT>; 		chomp($subband_base);
   $subband_sample_rate = <WORKUNIT>; chomp($subband_sample_rate);
   $fft_len = <WORKUNIT>; 			chomp($fft_len);
   $ifft_len = <WORKUNIT>; 			chomp($ifft_len);
   $subband_number = <WORKUNIT>; 	chomp($subband_number);
   $receiver = <WORKUNIT>; 			chomp($receiver);
   $nsamples = <WORKUNIT>; 			chomp($nsamples);
   $tape_version = <WORKUNIT>; 		chomp($tape_version);
   $num_positions = <WORKUNIT>; 	chomp($num_positions);
close(WORKUNIT) || message(2);

### Splitting into a good form
   ### .perlseti_data (the top gaussian and top spike data file) 
      ($bspikepwr_temp, $bspikepwr_value) = split(/=/, $bspikepwr);
      ($bspikescr_temp, $bspikescr_value) = split(/=/, $bspikescr);
      ($bgauspwr_temp, $bgauspwr_value) = split(/=/, $bgauspwr);
      ($bgausscr_temp, $bgausscr_value) = split(/=/, $bgausscr);
      ($spikera_temp, $old_spikedisc_ra) = split(/=/, $spikeloc_ra);
      ($spikedec_temp, $old_spikedisc_dec) = split(/=/, $spikeloc_dec);
      ($gausra_temp, $old_gausdisc_ra) = split(/=/, $gausloc_ra);
      ($gausdec_temp, $old_gausdisc_dec) = split(/=/, $gausloc_dec);  

   ### state.txt
      ($bsp_temp, $bsp_value) = split(/=/, $bs_power);
      ($bss_temp, $bss_value) = split(/=/, $bs_score);
      ($bgp_temp, $bgp_value) = split(/=/, $bg_power);
      ($bgs_temp, $bgs_value) = split(/=/, $bg_score);
      ($prog_temp, $prog_value) = split(/=/, $prog);
      $unitprog = ($prog_value * 100);
      ($cpu_temp, $cpu_value) = split(/=/, $cpu);

   ### version.txt
      ($major_temp, $major_value) = split(/=/, $client_major);
      ($minor_temp, $minor_value) = split(/=/, $client_minor);

   ### user_info.txt
      ($name_temp, $name_value) = split(/=/, $email_addr); 
      ($total_cpu_temp, $total_cpu_value) = split(/=/, $total_cpu);
      ($nwus_temp, $nwus_value) = split(/=/, $nwus);
      ($nresults_temp, $nresults_value) = split(/=/, $nresults);
      ($fl_temp, $fl_value) = split(/=/, $fl);
      ($cr_temp, $cr_value) = split(/=/, $cr);

   ### work_unit.txt
      ($freq_temp, $freq) = split(/=/, $subband_base);
      ($rectime_temp, $rectime_temp1, $rectime_temp2) = split(/\(/, $time_recorded);
      ($rectime, $rectime_temp3) = split(/\)/, $rectime_temp1);
      ($ra_temp, $ra) = split(/=/, $start_ra);
      ($dec_temp, $dec) = split(/=/, $start_dec);

$final_cpu_value = $cpu_value + $total_cpu_value; 	# also update the total_time
$freq2 = $freq * 10e-10; # get frequency in GHZ
##################################
### Finally display everything ###
##################################

#### START: b/w screen output ####

if($output_type eq "0") {

   ### Use clear or scrolling???
   if($know_clear eq "1") {
      use Term::Cap;
      
      $terminal = Term::Cap->Tgetent( {OSPEED => 9600} );
      $clear_string = $terminal->Tputs('cl');
      
      &logmsg("Starting client v$major_value.$minor_value") if $started<2;
      print $clear_string;
      print  $progname, " v", $progversion, " - SETI v", $major_value, ".", $minor_value, " - (c)1999 by Jan Rocho Port 2001 Achim Schneider\n\n"; 
   }

   if($know_clear eq "0") {
      &logmsg("Starting client v$major_value.$minor_value") if $started<2;
      print  $progname, " v", $progversion, " - SETI v", $major_value, ".", $minor_value, " - (c)1999 by Jan Rocho Port 2001 Achim Schneider\n\n"; 
   }

   if($know_clear eq "2") {
      &logmsg("Starting client v$major_value.$minor_value") if $started<2;
      system "cls";
      print  $progname, " v", $progversion, " - SETI v", $major_value, ".", $minor_value, " - (c)1999 by Jan Rocho Port 2001 Achim Schneider\n\n";    
   }

   print "Username       : ", $name_value,"\n",
   "Units RX/TX    : ", $nwus_value, " \/ ", $nresults_value, "\n",
   "CPU time       : "; show_total_cpu_time(0); print "\n",
   "Host           : ", $ENV{HOSTNAME}, " (PID: ", $client_pid, ")\n",
   "Source         : ", $sourceloc, "\n",
   "Best Spike     : ", $bspikepwr_value, " (Score: ", $bspikescr_value, ") (", $old_spikedisc_ra, " R.A. - ", $old_spikedisc_dec, " DEC)\n",
   "Best Gaussian  : ", $bgauspwr_value, " (Score: ", $bgausscr_value, ") (", $old_gausdisc_ra, " R.A. - ", $old_gausdisc_dec, " DEC)\n",
   "Base Freq.     : ", $freq2, " GHz\n",
   "Time Recorded  : ", $rectime, "\n",
   "Sky Coordinates: ", $ra, " R.A. - ", $dec, " DEC\n\n",
   "Spike Power    : ", $bsp_value, "   (Score: ",$bss_value,")\n",
   "Gaussian Power : ", $bgp_value, "   (Score: ",$bgs_value,")\n",
   "FFT Length     : ", $fl_value, "\n",
   "Dop Shift Rate : ", $cr_value, "\n",
   "Unit CPU time  : "; show_cpu_time(0); print "\n",
   "Unit end time  : "; show_end_time(0); print "\n",
   "Total Unit time: "; show_total_time(0); print "\n",
   "Done           : ", $unitprog, "\%\n";

   ### improved progress bar 0.6 instead of 0.8 because I put the progress bar on the same line of the label "Unit Progress:"
   $unitprogbar = ($unitprog * 0.6);

   print "Unit Progress : ";
   $counter = 0;
   print "[";  #start progbar
   do {
      print "#";
      $counter++;
   } until $counter >= $unitprogbar;
   do {
      print "-";  #blank space character
      $counter++;
   } until $counter >= 60;
   print "]"; #end progbar
   print "\n\n";
   
   message_state(1);
}
#### END: b/w screen output ####

#### START: color screen output ####
if($output_type eq "1") { 
   $ansi_color     = 1;
   $ansi_esc       = "\033[";
   $color_black    = "$ansi_esc" . "30\;47\;1m";   #    Black on White, Bold
   $color_red      = "$ansi_esc" . "31\;40\;1m";   #      Red on Black, Bold
   $color_green    = "$ansi_esc" . "32\;40\;1m";   #    Green on Black, Bold
   $color_yellow   = "$ansi_esc" . "33\;40\;1m";   #   Yellow on Black, Bold
   $color_blue     = "$ansi_esc" . "34\;40\;1m";   #     Blue on Black, Bold
   $color_purple   = "$ansi_esc" . "35\;40\;1m";   #   Purple on Black, Bold
   $color_ltblue   = "$ansi_esc" . "36\;40\;1m";   # Lt. Blue on Black, Bold
   $color_white    = "$ansi_esc" . "37\;40\;1m";   #    White on Black, Bold
   $color_ylw_wht  = "$ansi_esc" . "33\;47\;1m";   #   Yellow on Black, Bold
   $color_default  = $color_yellow;
   
   print $color_default;
   
   ### Use clear or scrolling???
   if($know_clear eq "1") {
      use Term::Cap;
      
      $terminal = Term::Cap->Tgetent( {OSPEED => 9600} );
      $clear_string = $terminal->Tputs('cl');
      
      &logmsg("Starting client v$major_value.$minor_value") if $started<2;
      print $clear_string;
            print  $progname, " v", $progversion, " - SETI v", $major_value, ".", $minor_value, " - (c)1999 by Jan Rocho Port 2001 Achim Schneider\n\n"; 
   }
   
   if($know_clear eq "0") {
      &logmsg("Starting client v$major_value.$minor_value") if $started<2;
            print  "\n\n", $progname, " v", $progversion, " - SETI v", $major_value, ".", $minor_value, " - (c)1999 by Jan Rocho Port 2001 Achim Schneider\n\n"; 
   }

   if($know_clear eq "2") {
      &logmsg("Starting client v$major_value.$minor_value") if $started<2;
      system "cls";
            print  $progname, " v", $progversion, " - SETI v", $major_value, ".", $minor_value, " - (c)1999 by Jan Rocho Port 2001 Achim Schneider\n\n";     
   }
   
   print "Username       : ", $color_white, $name_value,  $color_default, "\n",
   "Units RX/TX    : ", $color_purple, $nwus_value, " \/ ", $nresults_value, $color_default, "\n",
   "CPU time       : ",  $color_white; show_total_cpu_time(0); print  $color_default, "\n",
   "Host           : ", $color_white, $ENV{HOSTNAME}, " (PID: ", $client_pid, ")", $color_default, "\n",
   "Source         : ", $color_white, $sourceloc, $color_default, "\n",
   "Best Spike     : ", $color_purple, $bspikepwr_value, " (Score: ", $bspikescr_value, ") (", $old_spikedisc_ra, " R.A. - ", $old_spikedisc_dec, " DEC)", $color_default, "\n",
   "Best Gaussian  : ", $color_purple, $bgauspwr_value, " (Score: ", $bgausscr_value, ") (", $old_gausdisc_ra, " R.A. - ", $old_gausdisc_dec, " DEC)", $color_default, "\n",
   "Base Freq.     : ", $color_white, $freq2, " GHz", $color_default, "\n",
   "Time Recorded  : ", $color_green, $rectime, $color_default, "\n",
   "Sky Coordinates: ", $color_white, $ra, " R.A. - ", $dec, " DEC", $color_default,"\n\n",
   "Spike Power    : ", $color_white, $bsp_value, "   (Score: ",$bss_value,")", $color_default, "\n",
   "Gaussian Power : ", $color_white, $bgp_value, "   (Score: ",$bgs_value,")", $color_default, "\n",
   "FFT Length     : ", $color_white, $fl_value,  $color_default, "\n",
   "Dop Shift Rate : ", $color_white, $cr_value,  $color_default, "\n",
   "Unit CPU time  : ", $color_white; show_cpu_time(0); print $color_default, "\n",
   "Unit end time  : ", $color_white; show_end_time(0); print $color_default, "\n",
   "Total Unit time: ", $color_white; show_total_time(0); print $color_default, "\n",
   "Done           : ", $color_red, $unitprog, "\%",  $color_default, "\n";
   
   ### improved progress bar # 0.6 instead of 0.8 because I put the progress bar on the same line of the label "Unit Progress:"
   $unitprogbar = ($unitprog * 0.6);
   
   print "Unit Progress : ";
   $counter = 0;
   print $color_white, "[";  #start progbar
   print $color_red;
   do {
      print "#";
      $counter++;
   } until $counter >= $unitprogbar;
   print $color_white;
   do {
      print "-";  #blank space character
      $counter++;
   } until $counter >= 60;
   print $color_white, "]"; #end progbar
   
   if ($unitprog>97) {
      # if this logs too many of the results move to below
      &logmsg("Units completed: $nresults_value");
      &logmsg("Units sent     : $nwus_value");
      &logmsg("Time recorded  : $rectime");
      &logmsg("Spike Power    : $bsp_value -- Score: $bss_value");
      &logmsg("Gaussien Power : $bgp_value -- Score: $bgs_value");
      $totalcpu=$total_cpu_value/3600;
      $unitcpu=$cpu_value/3600;
      &logmsg("CPU time       : $totalcpu");
      &logmsg("Total CPU time : $unitcpu");
   }
   
   print $color_default, "\n\n";
   message_state(1);
}
#### END: color screen output ####

#### START: Simple HTML output #### 
if($html_output eq "1") {
   open(HTMLFILE, ">$html_output_path$html_output_file") || message(7); 
      print HTMLFILE "<html>\n",
      "<head><title>SETI\@home client status for ", $name_value, " <\/title><\/head>\n",
      "<body bgcolor=\"#ffffff\">\n",
      "<h1>SETI\@home client status for $name_value</h1>\n",
      "<pre>\n",
      "Username            : ", $name_value,"\n",
      "Units Received      : ", $nwus_value, "\n",
      "Units Returned      : ", $nresults_value, "\n",
      "CPU time            : "; show_total_cpu_time(1); print HTMLFILE "\n",
      "Host                : ", $ENV{HOSTNAME}, "\n"; client_pid_visible(0);
      print HTMLFILE 
      "Source              : ", $sourceloc, "\n",
      "Best Spike Power    : ", $bspikepwr_value, "\n",
      "Best Spike Score    : ", $bspikescr_value, "\n", 
      "Best Spike Loc.     : ", $old_spikedisc_ra, " R.A. - ", $old_spikedisc_dec, " DEC)\n",
      "Best Gaussian Power : ", $bgauspwr_value, "\n",
      "Best Gaussian Score : ", $bgausscr_value, "\n", 
      "Best Gaussian Loc.  : ", $old_gausdisc_ra, " R.A. - ", $old_gausdisc_dec, " DEC)\n",
      "Base Freq.          : ", $freq2, " GHz\n",
      "Time Recorded       : ", $rectime, "\n",
      "Sky Coordinates     : ", $ra, " R.A. - ", $dec, " DEC\n\n",

      "Spike Power         : ", $bsp_value, "\n",
      "Spike Score         : ", $bss_value, "\n",
      "Gaussian Power      : ", $bgp_value, "\n",
      "Gaussian Score      : ", $bgs_value, "\n",
      "FFT Length          : ", $fl_value, "\n",
      "Dop Shift Rate      : ", $cr_value, "\n",
      "Unit CPU time       : "; show_cpu_time(1); print HTMLFILE "\n",
      "Unit end time       : "; show_end_time(1); print HTMLFILE "\n",
      "Total Unit time     : "; show_total_time(1); print HTMLFILE "\n",
      "Done                : ", $unitprog, "\%\n\n";
   
      message_state(2);
  
      print HTMLFILE "</pre>\n",
      "<p>\n",
      "<hr>\n",
      "<font size=\"2\">Created with $progname v$progversion - &copy\;1999 by Jan Rocho port 2001 Achim Schneider</font><br>\n",
      "</body></html>";
   close(HTMLFILE) || message(7);
}
#### END: Simple HTML output ####

#### START: Table HTML output ####
if($html_output eq "2") {
   open(HTMLFILE, ">$html_output_path$html_output_file") || message(7);
      
      print HTMLFILE "<html>\n",
      "<head><title>SETI\@home client status for ", $name_value, " <\/title><\/head>\n",
      "<body bgcolor=\"#ffffff\">\n",
      "<h1 align=\"center\">SETI\@home client status for $name_value</h1>\n",
      "<table align=\"center\" border=\"3\">\n",
      "<tr><td><b>Username</b></td><td>",$name_value,"</td></tr>\n",
      "<tr><td><b>Units Received<br>Units Returned</b></td><td>",
      $nwus_value, "<br>", $nresults_value, "</td></tr>\n", 
      "<tr><td><b>CPU time</b></td><td>"; show_total_cpu_time(1); print HTMLFILE "</td></tr>\n",
      "<tr><td><b>Host</b></td><td>", $ENV{HOSTNAME}, "</td></tr>\n";
      client_pid_visible(1);
      print HTMLFILE 
      "<tr><td><b>Source</b></td><td>", $sourceloc, "</td></tr>\n",
      "<tr><td><b>Best Spike Power<br>Best Spike Score<br>Best Spike Loc.</b></td><td>", 
      $bspikepwr_value, "<br>", $bspikescr_value, "<br>", $old_spikedisc_ra, " R.A. - ", $old_spikedisc_dec, " DEC</td></tr>\n",
      "<tr><td><b>Best Gaussian Power<br>Best Gaussian Score<br>Best Gaussian Loc.</b></td><td>", 
      $bgauspwr_value, "<br>", $bgausscr_value, "<br>", $old_gausdisc_ra, " R.A. - ", $old_gausdisc_dec, " DEC</td></tr>\n",
      "<tr><td><b>Base Freq.</b></td><td>", $freq2, " GHz</td></tr>\n",
      "<tr><td><b>Time Recorded</b></td><td>", $rectime, "</td></tr>\n",
      "<tr><td><b>Sky Coordinat.</b></td><td>", $ra, " R.A. - ", $dec, " DEC</td></tr></table>\n\n<p>\n\n",
      
      "<table align=\"center\" border=\"3\">\n",
      "<tr><td><b>Spike Power<br>Spike Score</b></td><td>", 
      $bsp_value, "<br>",$bss_value,"</td></tr>\n",
      "<tr><td><b>Gaussian Power<br>Gaussian Score</b></td><td>", 
      $bgp_value, "<br>",$bgs_value,"</td></tr>\n",
      "<tr><td><b>FFT Length</b></td><td>", $fl_value, "</td></tr>\n",
      "<tr><td><b>Dop Shift Rate</b></td><td>", $cr_value, "</td></tr>\n",
      "<tr><td><b>Unit CPU time</b></td><td>"; show_cpu_time(1); print HTMLFILE "</td></tr>\n",
      "<tr><td><b>Unit end time</b></td><td>"; show_end_time(1); print HTMLFILE "</td></tr>\n",
      "<tr><td><b>Total Unit time</b></td><td>"; show_total_time(1); print HTMLFILE "</td></tr>\n",
      "<tr><td><b>Done</b></td><td>", $unitprog, "\%</td></tr></table>\n\n<p><center>\n\n";
      
      message_state(2);
  
      print HTMLFILE "</pre>\n",
      "</center><p>\n",
      "<hr>\n",
      "<font size=\"2\">Created with $progname v$progversion - &copy\;1999 by Jan Rocho port 2001 Achim Schneider</font><br>\n",
      "</body></html>";
   
   close(HTMLFILE) || message(7);
}
#### END: Table HTML output ####

### any new high scores???
### there should be a better way to do it but this one also does it.
  
if($bsp_value > $bspikepwr_value) {
   $new_spikepower = $bsp_value;
   $new_spikescore = $bss_value;
   $spikedisc_ra = $ra;
   $spikedisc_dec = $dec;
} else {
   $new_spikepower = $bspikepwr_value;
   $new_spikescore = $bspikescr_value;
   $spikedisc_ra = $old_spikedisc_ra;
   $spikedisc_dec = $old_spikedisc_dec;
} 

if($bgs_value > $bgausscr_value) {
   $new_gauspower = $bgp_value;
   $new_gausscore = $bgs_value;
   $gausdisc_ra = $ra;
   $gausdisc_dec = $dec;
} else {
   $new_gauspower = $bgauspwr_value;
   $new_gausscore = $bgausscr_value;
   $gausdisc_ra = $old_gausdisc_ra;
   $gausdisc_dec = $old_gausdisc_dec;
}

open(PERLSETI_DATA_WRITE, ">perlseti_data")	|| message(5);
   
   print PERLSETI_DATA_WRITE "bestspike_power=", $new_spikepower, "\n";
   print PERLSETI_DATA_WRITE "bestspike_score=", $new_spikescore, "\n";
   print PERLSETI_DATA_WRITE "bestspike_ra=", $spikedisc_ra, "\n";
   print PERLSETI_DATA_WRITE "bestspike_dec=", $spikedisc_dec, "\n";
   print PERLSETI_DATA_WRITE "bestgaussian_power=", $new_gauspower, "\n";
   print PERLSETI_DATA_WRITE "bestgaussian_score=", $new_gausscore, "\n";
   print PERLSETI_DATA_WRITE "bestgaussian_ra=", $gausdisc_ra, "\n";
   print PERLSETI_DATA_WRITE "bestgaussian_dec=", $gausdisc_dec, "\n";

close(PERLSETI_DATA_WRITE) || message(5);
  
sleep $refresh_time;
}

sub message {
   my($message_id) = @_;
   $state_message = $message_id;
   return $state_message;
}

sub logmsg {
   @moy = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
   ($sec,$min,$hour,$date,$moy,$year,$dow,$doy,$dst)=localtime(time);
   
   open (setilog,">>$setilog") || die ("cannot open $setilog -- $!");
   
      $date<10 ? print setilog ("  0$date ",$moy[$moy]) : print setilog ("  $date ",$moy[$moy]);
      if ($hour) {
         $hour<10 ? print setilog (" 0$hour:") : print setilog (" $hour:");
      } else {
         $hour<10 ? print setilog (" 0$hour:") : print setilog (" $hour:");
      }
      
      $min<10 ? print setilog ("0$min:") : print setilog ("$min:");
      $sec<10 ? print setilog ("0$sec ","SETI") : print setilog ("$sec ","SETI");
      print setilog (" @_\n");
   
   close(setilog);
}

### Doing all the Message_state work
sub message_state {
   my($message_nbr) = @_;
   
   ### this is the message_state for the screen output
   if($message_nbr eq "1") {
      
      if($state_message eq "0") {
         print("Message: Analyzing the work unit data ...\n");
      }
      
      if($state_message eq "1") {
         print("Message: Your \"state.txt\" file is currently being updated.\n");
      }
      
      if($state_message eq "2") {
         print("Message: Downloading new work unit ...\n");
      }
      
      if($state_message eq "3") {
         print("Message: Your user information is being updated ...\n");
      }
      
      if($state_message eq "4") {
         print("Message: Can't open the high-score data file for reading ...\n");
      }
      
      if($state_message eq "5") {
         print("Message: Can't open the high-score data file for writing ...\n");
      }
      
      if($state_message eq "6") {
         print("Message: Can't reset the high-score file ...\n");
      }
      
      if($state_message eq "7") {
         print("Message: Can't access the HTML output file!\n");
      }
      
      if($state_message eq "8") {
         print("Message: Can't open PID file!\n");
      } 
   }
   
   ### this is the message state for the html output
   if($message_nbr eq "2") {
      
      if($state_message eq "0") {
         print HTMLFILE ("Message: Analyzing the work unit data ...\n");
      }
      
      if($state_message eq "1") {
         print HTMLFILE ("Message: Your \"state.txt\" file is currently being updated.\n");
      }
  
      if($state_message eq "2") {
         print HTMLFILE ("Message: Downloading new work unit ...\n");
      }
  
      if($state_message eq "3") {
         print HTMLFILE ("Message: Your user information is being updated ...\n");
      }

      if($state_message eq "4") {
         print HTMLFILE ("Message: Can't open the high-score data file for reading ...\n");
      }
     
      if($state_message eq "5") {
         print HTMFILE ("Message: Can't open the high-score data file for writing ...\n");
      }
     
      if($state_message eq "6") {
         print HTMLFILE ("Message: Can't reset the high-score file ...\n");
      }

      if($state_message eq "7") {
         print HTMLFILE ("Message: Can't access the HTML output file!\n");
      }

      if($state_message eq "4") {
	 print HTMLFILE ("Message: Can't access the PID file!\n");
      }
   }
}

sub show_cpu_time {
   my($time_id) = @_; 
   $hours1 = int($cpu_value / 3600);
   $mins1 = ($cpu_value - ($hours1 * 3600)) / 60;
   $secs1 = ($cpu_value - ($hours1 * 3600)) % 60;

   if($time_id eq "0") {
      printf "%d hr %2d:0%d min", $hours1, $mins1, $secs1 if $secs1<10;
      printf "%d hr %2d:%d min", $hours1, $mins1, $secs1  if $secs1>9;
   }
  
   if($time_id eq "1") {
      printf HTMLFILE "%d hr %2d:0%d min", $hours1, $mins1, $secs1 if $secs1<10;
      printf HTMLFILE "%d hr %2d:%d min", $hours1, $mins1, $secs1  if $secs1>9;
   }
}

sub show_end_time {
   my($time_end) = @_; 
   $end = ((($cpu_value/($unitprog+0.000001))*100) - $cpu_value);
  
   $hours3 = int($end / 3600);
   $mins3 = ($end - ($hours3 * 3600)) / 60;
   $secs3 = ($end - ($hours3 * 3600)) % 60;

   if($time_end eq "0") {
      printf "%d hr %2d:0%d min", $hours3, $mins3, $secs3 if $secs3<10;
      printf "%d hr %2d:%d min", $hours3, $mins3, $secs3  if $secs3>9;
   }
  
   if($time_end eq "1") {
      printf HTMLFILE "%d hr %2d:0%d min", $hours3, $mins3, $secs3 if $secs3<10;
      printf HTMLFILE "%d hr %2d:%d min", $hours3, $mins3, $secs3  if $secs3>9;
   }
}

sub show_total_time {
   my($time_total) = @_; 
   $total = $end + $cpu_value;
  
   $hours4 = int($total / 3600);
   $mins4 = ($total - ($hours4 * 3600)) / 60;
   $secs4 = ($total - ($hours4 * 3600)) % 60;

   if($time_total eq "0") {
      printf "%d hr %2d:0%d min", $hours4, $mins4, $secs4 if $secs4<10;
      printf "%d hr %2d:%d min", $hours4, $mins4, $secs4  if $secs4>9;
   }
   
   if($time_total eq "1") {
      printf HTMLFILE "%d hr %2d:0%d min", $hours4, $mins4, $secs4 if $secs4<10;
      printf HTMLFILE "%d hr %2d:%d min", $hours4, $mins4, $secs4  if $secs4>9;
   }
}

sub show_total_cpu_time {
   my($total_time_id) = @_;
   $hours2 = int($final_cpu_value / 3600);
   $mins2 = ($final_cpu_value - ($hours2 * 3600)) / 60;
   $secs2 = ($final_cpu_value - ($hours2 * 3600)) % 60;
  
   if($total_time_id eq "0") {
      printf "%d hr %2d:0%d min", $hours2, $mins2, $secs2  if $secs2<10;
      printf "%d hr %2d:%d min",  $hours2, $mins2, $secs2  if $secs2>9;
   }
   
   if($total_time_id eq "1") {
      printf HTMLFILE "%d hr %2d:0%d min", $hours2, $mins2, $secs2  if $secs2<10;
      printf HTMLFILE "%d hr %2d:%d min",  $hours2, $mins2, $secs2  if $secs2>9;
   }
}

sub client_pid_visible {
   my($client_pid_visible_type) = @_;
   if($client_pid_visible_type eq "0") {
      if($html_show_pid eq "1") {
         print HTMLFILE "PID                 : ", $client_pid, "\n";
      }
   }
   
   if($client_pid_visible_type eq "1") {
      if($html_show_pid eq "1") {
         print HTMLFILE "<tr><td><b>PID</b></td><td>", $client_pid, "</td></tr>\n";
      }
   }
}

#### START: Top Ten List ####
#will be implanted in a future version.... just give me some time :-)
#someone has an idea how to do this? would be nice if someone could 
#hack this part together. thanks.
#
#the basic idea is that there will be a top-ten list in a text file, this
#should contain the last 10 spikes and gaussians as well as the location
#where they have been found and the time when they have been found
#### END: Top Ten List ####







